/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.wahllokalsystem.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class WahllokalsystemStatusUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;


  protected final de.ivu.elect.business.gebietsbaum.entity.GebietUK gebietUK;

    public de.ivu.elect.business.gebietsbaum.entity.GebietUK getGebietUK(){
      return gebietUK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlUK wahlUK;

    public de.ivu.elect.business.wahl.entity.WahlUK getWahlUK(){
      return wahlUK;
    }

  public WahllokalsystemStatusUK(
  de.ivu.elect.business.gebietsbaum.entity.GebietUK gebietUK
,   de.ivu.elect.business.wahl.entity.WahlUK wahlUK
  ) {
    super();


        this.gebietUK = gebietUK;
      this.wahlUK = wahlUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
        
                    result = result + ((gebietUK == null) ? 0 : gebietUK.hashCode());
                    result = result + ((wahlUK == null) ? 0 : wahlUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            WahllokalsystemStatusUK other = (WahllokalsystemStatusUK) obj;

        
                if (gebietUK == null) {
          if (other.gebietUK != null) {
            return false;
          }
        } else if (!gebietUK.equals(other.gebietUK)) {
          return false;
        }
                if (wahlUK == null) {
          if (other.wahlUK != null) {
            return false;
          }
        } else if (!wahlUK.equals(other.wahlUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return WahllokalsystemStatusConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietUK.getAllEntityFieldValues());
    result.addAll(wahlUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            return java.util.Collections.emptyList();
      }
  
    @Override
  public String toString() {
    return "WahllokalsystemStatusUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                                    +"gebietUK="+gebietUK
                            +", "                +"wahlUK="+wahlUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
          return list;
   }

            public static <E extends WahllokalsystemStatus> java.util.Map<WahllokalsystemStatusUK, E> mappeWahllokalsystemStatusNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(WahllokalsystemStatus::getWahllokalsystemStatusUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<WahllokalsystemStatus, WahllokalsystemStatusUK> getWahllokalsystemStatusToUKFunction() {
                return WahllokalsystemStatus::getWahllokalsystemStatusUK;
                }

}
